Index: trunk/platforms/tsar_generic_leti/tsar_leti_cluster/caba/source/include/tsar_leti_cluster.h
===================================================================
--- trunk/platforms/tsar_generic_leti/tsar_leti_cluster/caba/source/include/tsar_leti_cluster.h	(revision 803)
+++ trunk/platforms/tsar_generic_leti/tsar_leti_cluster/caba/source/include/tsar_leti_cluster.h	(revision 1029)
@@ -171,4 +171,5 @@
                      size_t                             tgtid_mtty,
                      size_t                             tgtid_bdev,
+                     bool                               use_ramdisk,
                      const char*                        disk_pathname,
                      size_t                             memc_ways,
Index: trunk/platforms/tsar_generic_leti/tsar_leti_cluster/caba/source/src/tsar_leti_cluster.cpp
===================================================================
--- trunk/platforms/tsar_generic_leti/tsar_leti_cluster/caba/source/src/tsar_leti_cluster.cpp	(revision 803)
+++ trunk/platforms/tsar_generic_leti/tsar_leti_cluster/caba/source/src/tsar_leti_cluster.cpp	(revision 1029)
@@ -37,4 +37,5 @@
          size_t                             tgtid_mtty,
          size_t                             tgtid_bdev,
+         bool                               use_ramdisk,
          const char*                        disk_pathname,
          size_t                             memc_ways,
@@ -170,6 +171,11 @@
     if ((x_id == 0) and (y_id == 0))  // cluster(0,0)
     {
-        nb_initiators = nb_procs + 1;
-        nb_targets    = 4;
+        nb_targets++; // TTY
+
+        if (not use_ramdisk)
+        {
+            nb_initiators++;
+            nb_targets++;
+        }
     }
 
@@ -291,13 +297,16 @@
     if ((x_id == 0) and (y_id == 0))
     {
-        /////////////////////////////////////////////
-        bdev = new VciBlockDeviceTsar<vci_param_int>(
-                     "bdev",
-                     mtd,
-                     IntTab(cluster_xy, nb_procs),
-                     IntTab(cluster_xy, tgtid_bdev),
-                     disk_pathname,
-                     512,
-                     64 );            // burst size
+        if (not use_ramdisk)
+        {
+            /////////////////////////////////////////////
+            bdev = new VciBlockDeviceTsar<vci_param_int>(
+                         "bdev",
+                         mtd,
+                         IntTab(cluster_xy, nb_procs),
+                         IntTab(cluster_xy, tgtid_bdev),
+                         disk_pathname,
+                         512,
+                         64 );            // burst size
+        }
 
         /////////////////////////////////////////////
@@ -378,6 +387,10 @@
     {
         xbar_cmd->p_to_target[tgtid_mtty]      (signal_vci_tgt_mtty);
-        xbar_cmd->p_to_target[tgtid_bdev]      (signal_vci_tgt_bdev);
-        xbar_cmd->p_to_initiator[nb_procs]     (signal_vci_ini_bdev);
+
+        if (not use_ramdisk)
+        {
+            xbar_cmd->p_to_target[tgtid_bdev]      (signal_vci_tgt_bdev);
+            xbar_cmd->p_to_initiator[nb_procs]     (signal_vci_ini_bdev);
+        }
     }
 
@@ -462,8 +475,8 @@
         if ((x_id == 0) and (y_id == 0)) // cluster (0,0)
         {
-            if      (i == 8)           xicu->p_hwi[i] (signal_irq_memc);
-            else if (i == 9)           xicu->p_hwi[i] (signal_irq_bdev);
-            else if (i == 10)          xicu->p_hwi[i] (signal_irq_mtty);
-            else                       xicu->p_hwi[i] (signal_false);
+            if      (i == 8)                     xicu->p_hwi[i] (signal_irq_memc);
+            else if (i == 9 and not use_ramdisk) xicu->p_hwi[i] (signal_irq_bdev);
+            else if (i == 10)                    xicu->p_hwi[i] (signal_irq_mtty);
+            else                                 xicu->p_hwi[i] (signal_false);
         }
         else                             // other clusters
@@ -499,12 +512,15 @@
     if ((x_id == 0) and (y_id == 0))
     {
-        // BDEV
-        bdev->p_clk                    (this->p_clk);
-        bdev->p_resetn                 (this->p_resetn);
-        bdev->p_irq                    (signal_irq_bdev);
-        bdev->p_vci_target             (signal_vci_tgt_bdev);
-        bdev->p_vci_initiator          (signal_vci_ini_bdev);
-
-        std::cout << "  - BDEV connected" << std::endl;
+        if (not use_ramdisk)
+        {
+            // BDEV
+            bdev->p_clk                    (this->p_clk);
+            bdev->p_resetn                 (this->p_resetn);
+            bdev->p_irq                    (signal_irq_bdev);
+            bdev->p_vci_target             (signal_vci_tgt_bdev);
+            bdev->p_vci_initiator          (signal_vci_ini_bdev);
+
+            std::cout << "  - BDEV connected" << std::endl;
+        }
 
         // MTTY (single channel)