Index: trunk/platforms/tsar_generic_xbar/scripts/run_simus.py
===================================================================
--- trunk/platforms/tsar_generic_xbar/scripts/run_simus.py	(revision 1023)
+++ trunk/platforms/tsar_generic_xbar/scripts/run_simus.py	(revision 1048)
@@ -17,8 +17,8 @@
 bscpu = 0 # bootstrap CPU
 nb_procs = [ 4 ]
-#nb_procs = [ 1, 4, 8, 16, 32, 64, 128, 256 ]
+#nb_procs = [ 1, 2, 4, 8, 16, 32, 64, 128, 256 ]
 rerun_stats = False
-use_omp = False
-protocol = 'rwt'
+use_omp = True
+protocol = 'dhccp'
 cpu_per_cluster = 4
 # mode must be one of 'test' and 'simu'
@@ -27,19 +27,24 @@
 #apps = [ 'cholesky', 'fft', 'fft_ga', 'filter', 'filt_ga', 'histogram', 'kmeans', 'lu', 'mandel', 'mat_mult', 'pca', 'radix_ga' ]
 #apps = [ 'histogram', 'mandel', 'filter', 'radix_ga', 'fft_ga', 'kmeans' ]
-#apps = [ 'blackscholes', 'linear_regression', 'string_match', 'swaptions', 'fluidanimate' ]
-apps = [ 'hello', 'taquin', '2048' ]
-
-
-# Variables which could be changed but ought not to because they are reflected in the create_graphs.py script
+apps = [ 'fal_sh_2' ]
+
+#apps = [ 'pca-opt', 'blackscholes', 'fft_ga', 'filt_ga', 'histo-opt', 'kmeans-opt', 'linear_regression', 'lu', 'mandel', 'radix_ga', 'string_match' ]
+#apps = [ 'pca-opt', 'blackscholes', 'fft_ga', 'filt_ga', 'histo-opt', 'kmeans-opt', 'linear_regression', 'lu', 'mandel', 'mat_mult-opt', 'radix_ga', 'string_match' ]
+
 if mode == 'test':
     data_dir = 'data_test'
 else:
     data_dir = 'data'
-log_init_name = protocol + '_stdo_'
+
+# Variables which could be changed but ought not to because they are reflected in the create_graphs.py script
+
+log_stdo_name = protocol + '_stdo_'
 log_term_name = protocol + '_term_'
 
+
 # Global Variables
 
-all_apps = [ '2048', 'blackscholes', 'boot_only', 'cholesky', 'fft', 'fft_ga', 'filter', 'filt_ga', 'fluidanimate', 'hello', 'histogram', 'histo-opt', 'kmeans', 'kmeans-opt', 'linear_regression', 'lu', 'mandel', 'mat_mult', 'mat_mult-opt', 'pca', 'pca-opt', 'radix', 'radix_ga', 'showimg', 'string_match', 'swaptions', 'taquin']
+all_modes = ['simu', 'test']
+all_apps = [ 'blackscholes', 'boot_only', 'cholesky', 'fal_sh_1', 'fal_sh_2', 'fft', 'fft_ga', 'filter', 'filt_ga', 'fluidanimate', 'hello', 'histogram', 'histo-opt', 'kmeans', 'kmeans-opt', 'linear_regression', 'lu', 'mandel', 'mat_mult', 'mat_mult-opt', 'pca', 'pca-opt', 'radix', 'radix_ga', 'showimg', 'string_match', 'swaptions', ]
 # to come: 'barnes', 'fmm', 'ocean', 'raytrace', 'radiosity', 'waters', 'watern'
 
@@ -60,5 +65,5 @@
 hard_config_name      = os.path.join(almos_path, "hard_config.h")
 bootloader_file_name  = os.path.join(almos_path, "bootloader-tsar-mipsel.bin")
-preloader_file_name   = os.path.join(almos_path, "preloader.elf")
+#preloader_file_name   = os.path.join(almos_path, "preloader.elf")
 preloader_build_path  = os.path.join(almos_path, "build_preloader")
 bootloader_build_path = os.path.join(almos_path, "build_bootloader")
@@ -227,5 +232,4 @@
     for common_module in common_modules:
         f.write("config.addDescPath(\"%s/%s\")\n" % (tsar_dir, common_module))
-    #f.write("\n")
 
     if protocol == "dhccp":
@@ -243,5 +247,4 @@
         f.write("config.addDescPath(\"%s/%s\")\n" % (arch_dir, specific_module))
 
-    #f.write("\n")
     f.close()
 
@@ -330,5 +333,5 @@
     print "cd", preloader_src_dir
     os.chdir(preloader_src_dir)
-    cmd = ['make', hard_conf_path_set, bscpu_set, 'USE_DT=0', 'BUILD_DIR=%s' % (preloader_build_path)]
+    cmd = ['make', hard_conf_path_set, bscpu_set, 'BLOCK_SIZE=4096', 'USE_32BIT=1', 'USE_DT=0', 'BUILD_DIR=%s' % (preloader_build_path)]
     retval = print_and_call(cmd)
     if retval != 0:
@@ -406,4 +409,8 @@
         elif (app_name == "boot_only"):
             shrc = "exec -p 0 /bin/boot_onl\n"
+        elif (app_name == "fal_sh_1"):
+            shrc = "exec -p 0 /bin/fal_sh_1 -n %(nproc)d -p %(niter)d\n" % dict(nproc = nprocs, niter = 100)
+        elif (app_name == "fal_sh_2"):
+            shrc = "exec -p 0 /bin/fal_sh_2 -n %(nproc)d -p %(niter)d\n" % dict(nproc = nprocs, niter = 100)
         elif (app_name == "filter"):
             shrc = "exec -p 0 /bin/filter -l 128 -c 128 -n %(nproc)d -i /etc/img128.raw\n" % dict(nproc = nprocs)
@@ -460,4 +467,8 @@
         elif (app_name == "cholesky"):
             shrc = "exec -p 0 /bin/cholesky -n%(nproc)d /etc/tk14.O\n" % dict(nproc = nprocs)
+        elif (app_name == "fal_sh_1"):
+            shrc = "exec -p 0 /bin/fal_sh_1 -n %(nproc)d -p %(niter)d\n" % dict(nproc = nprocs, niter = 10000)
+        elif (app_name == "fal_sh_2"):
+            shrc = "exec -p 0 /bin/fal_sh_2 -n %(nproc)d -p %(niter)d\n" % dict(nproc = nprocs, niter = 10000)
         elif (app_name == "fft"):
             shrc = "exec -p 0 /bin/fft -n%(nproc)d -m18\n" % dict(nproc = nprocs)
@@ -533,5 +544,4 @@
 print_and_call(cmd)
 
-#gen_sym_links()
 gen_soclib_conf()
 compile_almos()
@@ -580,5 +590,5 @@
         else:
             cmd = ['./simul.x']
-        filename = os.path.join(scripts_path, data_dir, app + '_' + log_init_name + str(i))
+        filename = os.path.join(scripts_path, data_dir, app + '_' + log_stdo_name + str(i))
         output = print_and_popen(cmd, filename)
  
@@ -613,5 +623,5 @@
             else:
                 cmd = ['./simul.x', '--reset-counters', start2, '--dump-counters', end]
-            filename = os.path.join(scripts_path, data_dir, app + '_' + log_init_name + str(i))
+            filename = os.path.join(scripts_path, data_dir, app + '_' + log_stdo_name + str(i))
             output = print_and_popen(cmd, filename)
            